//
//  B6AppDelegate.swift
//  BASE64
//
//  Created by narita on 2019/02/01.
//  Copyright © 2019 narita. All rights reserved.
//

import Cocoa

@NSApplicationMain
class B6AppDelegate: NSObject, NSApplicationDelegate
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    override init()
    {
        super.init()
    }
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    // MARK: - event handling methods

    // 受け取とるだけ
    @objc func base64ServiceName(_ pasteboard: NSPasteboard,
                                 userData: String?,
                                 error: NSErrorPointer)
    {
        // ドット表記だとKVOされなかったので、setValueForKeyを使いKVOでUIに反映させる
        self.model?.setValue(pasteboard.string(forType: .string),
                             forKey: "planeString")
    }
    
    // 受け取って、返す
    @objc func base64RetuenServiceName(_ pasteboard: NSPasteboard,
                                       userData: String?,
                                       error: NSErrorPointer)
    {
        self.model?.setValue(pasteboard.string(forType: .string),
                             forKey: "planeString")
        
        // さらにペーストボードに値を設定する
        if let theReturnString = self.model?.convertedString
        {
            pasteboard.clearContents()
            pasteboard.setString(theReturnString as String, forType: .string)
        }
    }

    // 返すだけ
    @objc func insertDateServiceName(_ pasteboard: NSPasteboard,
                                       userData: String?,
                                       error: NSErrorPointer)
    {
        // 現在の日時を出力
        let theReturnString = Date().description
        
        pasteboard.clearContents()
        pasteboard.setString(theReturnString as String, forType: .string)
    }

    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods

    func applicationDidFinishLaunching(_ aNotification: Notification)
    {
        // サービスのメソッドを実装するオブジェクトの登録
        NSApp.servicesProvider = self
        
        // OSへサービスメニューの内容のUpdateを依頼する
        NSUpdateDynamicServices()
    }

    func applicationWillTerminate(_ aNotification: Notification)
    {
        
    }

    // このメソッドがYESを返す事で最後のWindowがクローズされた時にアプリケーションが終了します
    // Windowは一個しかないので、クローズされたら、終了する。
    func applicationShouldTerminateAfterLastWindowClosed(_ anApplication: NSApplication) -> Bool
    {
        return true
    }

    // MARK: - accessor methods (in pairs)
    
    @objc lazy var model: B6Model? =
    {
        return B6Model.init()
    }()

    // MARK: - Utility methods


}

